Index: sandbox/workflow/trunk/inc/class.ui_userinterface.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_userinterface.inc.php	(revision 2107)
+++ sandbox/workflow/trunk/inc/class.ui_userinterface.inc.php	(revision 2372)
@@ -45,5 +45,5 @@
 		$GLOBALS['phpgw_info']['flags']['app_header'] = $GLOBALS['phpgw_info']['apps']['workflow']['title'];
 		$GLOBALS['phpgw_info']['flags'] = array('noheader' => false, 'nonavbar' => false, 'currentapp' => 'workflow');
-		$smarty = CreateObject('workflow.workflow_smarty');
+		$smarty = Factory::getInstance('workflow_smarty');
 
 		// Check if workflow config is ok
@@ -114,8 +114,8 @@
 
 		// Get a connection to db workflow and galaxia (module)
-		if ($GLOBALS['workflow']['workflowObjects']->getDBWorkflow()->Error)
+		if (Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Error)
 			$errors[] = 'Unable to connect to database Workflow';
 
-		if ($errormsg = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Error)
+		if ($errormsg = Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Error)
 			$errors[] = 'Unable to connect to database Galaxia';
 
@@ -129,7 +129,6 @@
 
 		/* create some objects */
-		require_once 'class.so_userinterface.inc.php';
-		$so = new so_userinterface();
-		$smarty = CreateObject('workflow.workflow_smarty');
+		$so = &Factory::getInstance('so_userinterface');
+		$smarty = &Factory::getInstance('workflow_smarty');
 
 		/* get the user's organization */
Index: sandbox/workflow/trunk/inc/class.bo_move_instances.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_move_instances.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_move_instances.inc.php	(revision 2372)
@@ -12,6 +12,4 @@
 
 require_once('class.bo_ajaxinterface.inc.php');
-require_once('class.so_move_instances.inc.php');
-require_once('nano/JSON.php');
 
 
@@ -39,5 +37,5 @@
 	{
 		parent::bo_ajaxinterface();
-		$this->so = new so_move_instances();
+		$this->so = &Factory::getInstance('so_move_instances');
 	}
 
@@ -79,5 +77,5 @@
 	function moveInstances($params)
 	{
-		$JSON = new Services_JSON();
+		$JSON = &Factory::newInstance('Services_JSON');
 
 		/* convert the mappgin element to array */
Index: sandbox/workflow/trunk/inc/class.TemplateServer.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.TemplateServer.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.TemplateServer.inc.php	(revision 2372)
@@ -99,5 +99,5 @@
 				else
 				{
-					$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+					Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 					if (!isset($GLOBALS['phpgw_info']['login_template_set']))
 						return false;
@@ -131,5 +131,5 @@
 				{
 					/* se não for encontrado em nenhuma variável de ambiente, tenta carregar do banco de dados */
-					$webServerURL = (string) $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->GetOne('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'webserver_url'));
+					$webServerURL = (string) Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->GetOne('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'webserver_url'));
 					$this->WEB_WORKFLOW_BASE = str_replace('//', '/', "{$webServerURL}/workflow");
 				}
Index: sandbox/workflow/trunk/inc/class.ui_adminjobs.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_adminjobs.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_adminjobs.inc.php	(revision 2372)
@@ -41,5 +41,5 @@
 			'app_header' => $GLOBALS['phpgw_info']['apps']['workflow']['title'] . ' - ' . lang('Jobs')
 		);
-		$smarty = &$GLOBALS['workflow']['factory']->getInstance('workflow_smarty');
+		$smarty = &Factory::getInstance('workflow_smarty');
 
 		$javaScripts = $this->get_common_js();
@@ -54,5 +54,5 @@
 		$css .= $this->get_css_link('adminjobs');
 
-		$processInfo = $GLOBALS['workflow']['factory']->getInstance('workflow_processmanager')->get_process((int) $_REQUEST['p_id']);
+		$processInfo = Factory::getInstance('workflow_processmanager')->get_process((int) $_REQUEST['p_id']);
 		$smarty->assign('processNameVersion', "{$processInfo['wf_name']} v{$processInfo['wf_version']}");
 		$smarty->assign('processID', (int) $processInfo['wf_p_id']);
Index: sandbox/workflow/trunk/inc/class.workflow_processmanager.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_processmanager.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_processmanager.inc.php	(revision 2372)
@@ -5,7 +5,5 @@
 
 	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'RoleManager.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Process.php');
+
 	/**
 	 * @package Workflow
@@ -26,5 +24,5 @@
 			'database_user',
 			'database_password'
-		); 
+		);
 	   /**
 		 * Constructor
@@ -34,7 +32,7 @@
 		function workflow_processmanager()
 		{
-			parent::ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-			$this->workflow_acl = CreateObject('workflow.workflow_acl');
-			
+			parent::ProcessManager();
+			$this->workflow_acl = Factory::getInstance('workflow_acl');
+
 			/* allow regular users to see the process graph */
 			if ($_GET['menuaction'] == "workflow.ui_adminactivities.show_graph")
@@ -62,5 +60,5 @@
 		function import_process(&$data)
 		{
-			if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+			if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 
 			if (parent::import_process($data))
@@ -121,7 +119,7 @@
 		function serialize_process($pId)
 	  	{
-			if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
+			if (!(isset($this->activity_manager)))  $this->activity_manager = &Factory::newInstance('ActivityManager');
 			if (!isset($this->jobManager))
-				$this->jobManager = new JobManager($this->db);
+				$this->jobManager = &Factory::newInstance('JobManager');
 		
 			//if (!(isset($this->activity_manager)))  $this->activity_manager = new ActivityManager($this->db);
Index: sandbox/workflow/trunk/inc/class.ui_generic_select.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_generic_select.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_generic_select.inc.php	(revision 2372)
@@ -79,5 +79,5 @@
 	function form()
 	{
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
+		$smarty = Factory::getInstance('workflow_smarty', false);
 		$smarty->setHeader(workflow_smarty::SHOW_HEADER | workflow_smarty::SHOW_FOOTER);
 
Index: sandbox/workflow/trunk/inc/class.CachedLDAP.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.CachedLDAP.inc.php	(revision 1310)
+++ sandbox/workflow/trunk/inc/class.CachedLDAP.inc.php	(revision 2372)
@@ -97,8 +97,8 @@
 
 		/* load the information and establish a connection */
-		$tmpLDAP = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$tmpLDAP =& Factory::getInstance('WorkflowLDAP');
 		$this->userContext  = $tmpLDAP->getUserContext();
 		$this->groupContext = $tmpLDAP->getGroupContext();
-		$this->dataSource = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
+		$this->dataSource =& Factory::getInstance('WorkflowObjects')->getLDAP();
 	}
 
@@ -115,5 +115,5 @@
 
 		/* establish a connection */
-		$this->DBLink = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
+		$this->DBLink =& Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
 	}
 
Index: sandbox/workflow/trunk/inc/class.ui_adminprocesses.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_adminprocesses.inc.php	(revision 989)
+++ sandbox/workflow/trunk/inc/class.ui_adminprocesses.inc.php	(revision 2372)
@@ -1,3 +1,4 @@
 <?php
+require_once 'common.inc.php';
 require_once(dirname(__FILE__) . SEP . 'class.bo_workflow_forms.inc.php');
 require_once('engine' . SEP . 'config.egw.inc.php');
@@ -54,5 +55,5 @@
 		parent::bo_workflow_forms('admin_processes');
 
-		$this->workflow_acl = CreateObject('workflow.workflow_acl');
+		$this->workflow_acl = Factory::getInstance('workflow_acl');
 		$denyAccess = true;
 		if ($this->workflow_acl->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
@@ -83,6 +84,6 @@
 		}
 
-		$this->process_manager	= CreateObject('workflow.workflow_processmanager');
-		$this->activity_manager	= CreateObject('workflow.workflow_activitymanager');
+		$this->process_manager	= Factory::getInstance('workflow_processmanager');
+		$this->activity_manager	= Factory::getInstance('workflow_activitymanager');
 
 		$this->form_action = $GLOBALS['phpgw']->link('/index.php', 'menuaction=workflow.ui_adminprocesses.form');
@@ -127,5 +128,5 @@
 		}
 
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
 		{
 			$proc_ids = $this->workflow_acl->get_granted_processes($GLOBALS['phpgw_info']['user']['account_id']);
@@ -190,5 +191,5 @@
 		$known_config_items = array_merge($known_config_items, array('Log Options' => 'title', 'log_level' => $log_levels));
 
-		$bo_agent = CreateObject('workflow.bo_agent_mail_smtp');
+		$bo_agent = Factory::getInstance('bo_agent_mail_smtp');
 		$known_config_items = array_merge($known_config_items, $bo_agent->listProcessConfigurationFields());
 
@@ -589,5 +590,5 @@
 
 			$myp_id = $item['wf_p_id'];
-			$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+			$templateServer = &Factory::getInstance('TemplateServer');
 			$this->t->set_var(array(
 				'item_wf_p_id'		=> $myp_id,
Index: sandbox/workflow/trunk/inc/class.so_move_instances.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_move_instances.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.so_move_instances.inc.php	(revision 2372)
@@ -11,6 +11,4 @@
 \**************************************************************************/
 
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
 
 /**
@@ -91,6 +89,6 @@
 		$this->userID = $_SESSION['phpgw_info']['workflow']['account_id'];
 		$this->isAdmin = $_SESSION['phpgw_info']['workflow']['user_is_admin'];
-		$this->acl = &$GLOBALS['ajax']->acl;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
+		$this->acl =& $GLOBALS['ajax']->acl;
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
 	}
 
@@ -113,5 +111,5 @@
 				$where[] = 'wf_p_id IS NULL';
 		}
-		$processManager = new ProcessManager($this->db);
+		$processManager = &Factory::getInstance('ProcessManager', $this->db);
 
 		/* workaround to sort the result using two columns */
@@ -137,5 +135,5 @@
 		$this->_checkAccess($processID);
 
-		$activityManager = new ActivityManager($this->db);
+		$activityManager = &Factory::newInstance('ActivityManager');
 		$activities = $activityManager->list_activities($processID, 0, -1, 'wf_name__ASC', '', 'wf_type <> \'standalone\' AND wf_type <> \'view\'');
 		$output = array();
Index: sandbox/workflow/trunk/inc/class.workflow_activitymanager.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_activitymanager.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_activitymanager.inc.php	(revision 2372)
@@ -5,7 +5,4 @@
 
 	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'GraphViz.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'common' . SEP . 'WfSecurity.php');
 	/**
 	 * @package Workflow
@@ -20,5 +17,5 @@
 		function workflow_activitymanager()
 		{
-			parent::ActivityManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::ActivityManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.WorkflowObjects.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowObjects.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowObjects.inc.php	(revision 2372)
@@ -87,5 +87,5 @@
 			{
 				/* connect to the database */
-				$this->cache['DBGalaxia'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+				$this->cache['DBGalaxia'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 				$this->cache['DBGalaxia']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 				$this->cache['DBGalaxia']->Halt_On_Error = 'no';
@@ -98,6 +98,6 @@
 					$dbConfigValues['workflow_database_type']
 				);
-				$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBGalaxia']);
-				$this->cache['DBGalaxia']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBGalaxia']->Link_ID);
+				Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBGalaxia']);
+				$this->cache['DBGalaxia']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBGalaxia']->Link_ID);
 			}
 			else
@@ -128,5 +128,5 @@
 			if (!isset($connectionInfo['db_name']))
 			{
-				$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+				Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 				if (isset($GLOBALS['phpgw_info']['server']))
 					$connectionInfo = $GLOBALS['phpgw_info']['server'];
@@ -136,5 +136,5 @@
 
 			/* connect to the database */
-			$this->cache['DBExpresso'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+			$this->cache['DBExpresso'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 			$this->cache['DBExpresso']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 			$this->cache['DBExpresso']->Halt_On_Error = 'no';
@@ -147,6 +147,6 @@
 				$connectionInfo['db_type']
 			);
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBExpresso']);
-			$this->cache['DBExpresso']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBExpresso']->Link_ID);
+			Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBExpresso']);
+			$this->cache['DBExpresso']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBExpresso']->Link_ID);
 		}
 
@@ -177,5 +177,5 @@
 
 			/* connect to the database */
-			$this->cache['DBWorkflow'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+			$this->cache['DBWorkflow'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 			$this->cache['DBWorkflow']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 			$this->cache['DBWorkflow']->Halt_On_Error = 'no';
@@ -188,6 +188,6 @@
 				$dbConfigValues['database_type']
 			);
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBWorkflow']);
-			$this->cache['DBWorkflow']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBWorkflow']->Link_ID);
+			Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBWorkflow']);
+			$this->cache['DBWorkflow']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBWorkflow']->Link_ID);
 		}
 
Index: sandbox/workflow/trunk/inc/class.bo_ajaxinterface.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_ajaxinterface.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_ajaxinterface.inc.php	(revision 2372)
@@ -36,9 +36,6 @@
 
 require_once(PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'common.inc.php');
-require_once(PHPGW_API_INC . SEP . 'class.db.inc.php');
-require_once(PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'engine' . SEP . 'class.ajax_ldap.inc.php');
 require_once(PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'engine' . SEP . 'class.ajax_config.inc.php');
 require_once(PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'engine' . SEP . 'config.ajax.inc.php');
-require_once(PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'class.so_adminaccess.inc.php');
 
 /**
@@ -66,13 +63,13 @@
 		if (isset($_SESSION['phpgw_info']['workflow']['account_id']))
 		{
-			$GLOBALS['ajax']->ldap = new ajax_ldap();
-			$GLOBALS['ajax']->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+			$GLOBALS['ajax']->ldap = &Factory::getInstance('ajax_ldap');
+			$GLOBALS['ajax']->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
 			$GLOBALS['ajax']->db->Halt_On_Error = 'no';
 
-			$GLOBALS['ajax']->db_workflow = &$GLOBALS['workflow']['workflowObjects']->getDBWorkflow();
+			$GLOBALS['ajax']->db_workflow =& Factory::getInstance('WorkflowObjects')->getDBWorkflow();
 			$GLOBALS['ajax']->db_workflow->Halt_On_Error = 'no';
 
 			$GLOBALS['phpgw']->ADOdb = &$GLOBALS['ajax']->db->Link_ID;
-			$GLOBALS['ajax']->acl = new so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			$GLOBALS['ajax']->acl = &Factory::getInstance('so_adminaccess', Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 		else
Index: sandbox/workflow/trunk/inc/class.ui_external_applications.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_external_applications.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_external_applications.inc.php	(revision 2372)
@@ -49,5 +49,5 @@
 	function draw()
 	{
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
 		{
 			$GLOBALS['phpgw']->common->phpgw_header();
@@ -61,5 +61,5 @@
 		$GLOBALS['phpgw_info']['flags']['app_header'] = $GLOBALS['phpgw_info']['apps']['workflow']['title'];
 		$GLOBALS['phpgw_info']['flags'] = array('noheader' => false, 'nonavbar' => false, 'currentapp' => 'workflow');
-		$smarty = CreateObject('workflow.workflow_smarty');
+		$smarty = Factory::getInstance('workflow_smarty');
 
 		$this->set_wf_session();
Index: sandbox/workflow/trunk/inc/class.UserPictureProvider.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.UserPictureProvider.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.UserPictureProvider.inc.php	(revision 2372)
@@ -114,5 +114,5 @@
 					/* em último caso, tenta buscar a informação em banco de dados */
 					/* prepara o ambiente para a carga de informações sobre o banco de dados */
-					$result = $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
+					$result = Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
 					if (empty($result))
 						return;
@@ -141,5 +141,5 @@
 				mkdir($baseDirectory, 0770, true);
 
-			$contents = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserPicture($this->userID);
+			$contents = Factory::getInstance('WorkflowLDAP')->getUserPicture($this->userID);
 			$success = true;
 			if ($contents !== false)
@@ -165,5 +165,5 @@
 		}
 
-		$GLOBALS['workflow']['factory']->getInstance('ResourcesRedirector')->show($filename);
+		Factory::getInstance('ResourcesRedirector')->show($filename);
 	}
 }
Index: sandbox/workflow/trunk/inc/class.workflow_rolemanager.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_rolemanager.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_rolemanager.inc.php	(revision 2372)
@@ -17,5 +17,5 @@
 		function workflow_rolemanager()
 		{
-			parent::RoleManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::RoleManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.so_agent.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_agent.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.so_agent.inc.php	(revision 2372)
@@ -26,8 +26,8 @@
 {
 	//public functions
-	
+
 	/**
 	 * @var array $public_functions Array of public functions
-	 * @access public 
+	 * @access public
 	 */
 	var $public_functions = array(
@@ -36,34 +36,34 @@
 	);
 	/**
-	 * @var array $wf_table 
+	 * @var array $wf_table
 	 * @access public
 	 */
 	var $wf_table = 'egw_wf_agent_';
 	/**
-	 * @var string $agent_table 
+	 * @var string $agent_table
 	 * @access public
 	 */
 	var $agent_table = '';
-	
+
 	// link to the global db-object
-	
+
 	/**
-	 * @var object $db objeto para conexao do banco de dados 
+	 * @var object $db objeto para conexao do banco de dados
 	 * @access public
 	 */
 	var $db;
-	
+
 	/**
 	 * Constructor of the so_agent class
 	 * do not forget to call it (parent::so_agent();) in child classes
 	 * @access public
-	 * @return object 
+	 * @return object
 	 */
-	
+
 	function so_agent()
 	{
-		$this->db =& $GLOBALS['workflow']['workflowObjects']->getDBGalaxia();
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBGalaxia();
 	}
-	
+
 	/**
 	 * @abstract read all agent datas from the database
Index: sandbox/workflow/trunk/inc/class.bo_workflow_forms.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_workflow_forms.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_workflow_forms.inc.php	(revision 2372)
@@ -90,5 +90,5 @@
 			$this->sort_mode	= $this->order . '__' . $this->sort;
 			$this->search_str	= get_var('find', 'any', '');
-			$this->nextmatchs	= CreateObject('phpgwapi.nextmatchs');
+			$this->nextmatchs	= Factory::getInstance('nextmatchs');
 			
 			// number of rows allowed
Index: sandbox/workflow/trunk/inc/class.WorkflowSecurity.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowSecurity.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowSecurity.inc.php	(revision 2372)
@@ -51,5 +51,5 @@
 	{
 		/* garante que o objeto de DataBase do Expresso estará disponível */
-		$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+		Factory::getInstance('WorkflowObjects')->getDBExpresso();
 	}
 
@@ -77,5 +77,5 @@
 				continue;
 			$this->removeSensitiveInformationFromDatabaseObject($variable);
-			$variable = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $variable);
+			$variable = Factory::newInstance('WorkflowWatcher', $variable);
 		}
 	}
Index: sandbox/workflow/trunk/inc/engine/config.egw.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/config.egw.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/config.egw.inc.php	(revision 2372)
@@ -151,5 +151,5 @@
 	function galaxia_user_can_admin_process()
 	{
-		return ($GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('admin_workflow', 1, 'workflow'));
+		return (Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('admin_workflow', 1, 'workflow'));
 	}
 }
@@ -165,5 +165,5 @@
 	function galaxia_user_can_admin_instance()
 	{
-		return ($GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('admin_instance_workflow', 1, 'workflow'));
+		return (Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('admin_instance_workflow', 1, 'workflow'));
 	}
 }
@@ -179,5 +179,5 @@
 	function galaxia_user_can_clean_instances()
 	{
-		return ($GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('cleanup_workflow', 1, 'workflow'));
+		return (Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('cleanup_workflow', 1, 'workflow'));
 	}
 }
@@ -191,5 +191,5 @@
 	function galaxia_user_can_clean_aborted_instances()
 	{
-		return ($GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('cleanup_aborted_workflow', 1, 'workflow'));
+		return (Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('cleanup_aborted_workflow', 1, 'workflow'));
 	}
 }
@@ -203,5 +203,5 @@
 	function galaxia_user_can_monitor()
 	{
-		return ($GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('monitor_workflow', 1, 'workflow'));
+		return (Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']) || $GLOBALS['phpgw']->acl->check('monitor_workflow', 1, 'workflow'));
 	}
 }
@@ -221,5 +221,5 @@
 				$user = $GLOBALS['phpgw_info']['user']['account_id'];
 
-			$memberships = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserGroups($user);
+			$memberships = Factory::getInstance('WorkflowLDAP')->getUserGroups($user);
 
 			if ($memberships === false)
@@ -245,5 +245,5 @@
 		{
 			/* get information regarding the members of the group */
-			$members = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getGroupUsers($group);
+			$members = &Factory::getInstance('WorkflowLDAP')->getGroupUsers($group);
 
 			/* checl for error in the LDAP query */
@@ -305,5 +305,5 @@
 		{
 			// This way we create a new run_activity instance for the next activity
-			$run_activity = CreateObject('workflow.run_activity.go');
+			$run_activity = Factory::getInstance('run_activity');
 			$data = $run_activity->go($activityId, $iid, $auto);
 			return $data;
@@ -325,5 +325,5 @@
 	function galaxia_get_config_values($parameters=array())
 	{
-			$config = CreateObject('phpgwapi.config');
+			$config = Factory::getInstance('config');
 			$config->read_repository();
 
Index: sandbox/workflow/trunk/inc/engine/class.ajax_ldap.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/class.ajax_ldap.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/class.ajax_ldap.inc.php	(revision 2372)
@@ -29,9 +29,9 @@
 	function ajax_ldap()
 	{
-		$tmpLDAP = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$tmpLDAP = &Factory::getInstance('WorkflowLDAP');
 		$this->user_context  = $tmpLDAP->getUserContext();
 		$this->group_context = $tmpLDAP->getGroupContext();
 
-		$this->ds = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
+		$this->ds =& Factory::getInstance('WorkflowObjects')->getLDAP();
 	}
 
@@ -83,5 +83,5 @@
 	function id2fullname($account_id)
     {
-		return $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($account_id);
+		return Factory::getInstance('WorkflowLDAP')->getName($account_id);
     }
 
@@ -107,5 +107,5 @@
 			$accountID = $_SESSION['phpgw_info']['workflow']['account_id'];
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap =& Factory::getInstance('WorkflowLDAP');
 		if (count($output = $ldap->getUserGroups($accountID)) == 0)
 			return false;
Index: sandbox/workflow/trunk/inc/engine/config.ajax.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/engine/config.ajax.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/engine/config.ajax.inc.php	(revision 2372)
@@ -170,5 +170,5 @@
 		if ($loadGroups)
 		{
-			$memberships = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserGroups($user);
+			$memberships = Factory::getInstance('WorkflowLDAP')->getUserGroups($user);
 			if ($user == $_SESSION['phpgw_info']['workflow']['account_id'])
 				$_SESSION['phpgw_info']['workflow']['user_groups'] = $memberships;
@@ -196,5 +196,5 @@
 		{
 			/* get information regarding the members of the group */
-			$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+			$ldap = &Factory::getInstance('WorkflowLDAP');
 			$members = $ldap->getGroupUsers($group);
 
@@ -256,5 +256,5 @@
 	function galaxia_get_config_values($parameters=array())
 	{
-			$config = new ajax_config();
+			$config = &Factory::getInstance('ajax_config');
 			$config->read_repository();
 
